"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BoldSpecs = exports.boldType = exports.boldMarkName = void 0;
const schema_1 = require("../../../../utils/schema");
exports.boldMarkName = 'strong';
exports.boldType = (0, schema_1.markTypeFactory)(exports.boldMarkName);
const BoldSpecs = (builder) => {
    builder.addMark(exports.boldMarkName, () => ({
        spec: {
            parseDOM: [
                { tag: 'b' },
                { tag: 'strong' },
                {
                    style: 'font-weight',
                    getAttrs: (value) => /^(bold(er)?|[5-9]\d{2,})$/.test(value) && null,
                },
            ],
            toDOM() {
                return ['strong'];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: exports.boldMarkName,
                type: 'mark',
            },
        },
        toYfm: { open: '**', close: '**', mixable: true, expelEnclosingWhitespace: true },
    }));
};
exports.BoldSpecs = BoldSpecs;
