"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Breaks = exports.sbType = exports.hbType = exports.BreakNodeName = exports.BreaksSpecs = void 0;
const prosemirror_commands_1 = require("prosemirror-commands");
const logger_1 = require("../../../logger");
const platform_1 = require("../../../utils/platform");
const BreaksSpecs_1 = require("./BreaksSpecs");
var BreaksSpecs_2 = require("./BreaksSpecs");
Object.defineProperty(exports, "BreaksSpecs", { enumerable: true, get: function () { return BreaksSpecs_2.BreaksSpecs; } });
Object.defineProperty(exports, "BreakNodeName", { enumerable: true, get: function () { return BreaksSpecs_2.BreakNodeName; } });
Object.defineProperty(exports, "hbType", { enumerable: true, get: function () { return BreaksSpecs_2.hbType; } });
Object.defineProperty(exports, "sbType", { enumerable: true, get: function () { return BreaksSpecs_2.sbType; } });
const Breaks = (builder, opts) => {
    var _a;
    builder.use(BreaksSpecs_1.BreaksSpecs);
    let preferredBreak;
    if (builder.context.has('breaks')) {
        preferredBreak = builder.context.get('breaks') ? 'soft' : 'hard';
    }
    else {
        preferredBreak = (_a = opts.preferredBreak) !== null && _a !== void 0 ? _a : 'hard';
        logger_1.logger.info("[Breaks extension]: Parameter 'breaks' is not defined in context; value from options is used");
    }
    builder.addKeymap(({ schema }) => {
        const cmd = addBr((preferredBreak === 'soft' ? BreaksSpecs_1.sbType : BreaksSpecs_1.hbType)(schema));
        const keys = {
            'Shift-Enter': cmd,
        };
        if ((0, platform_1.isMac)()) {
            keys['Ctrl-Enter'] = cmd;
        }
        return keys;
    });
};
exports.Breaks = Breaks;
const addBr = (br) => (0, prosemirror_commands_1.chainCommands)(prosemirror_commands_1.exitCode, (state, dispatch) => {
    dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.replaceSelectionWith(br.create()).scrollIntoView());
    return true;
});
