"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeflistSpecs = exports.defDescType = exports.defTermType = exports.defListType = exports.DeflistNode = void 0;
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
const mdPlugin = require('markdown-it-deflist');
var const_2 = require("./const");
Object.defineProperty(exports, "DeflistNode", { enumerable: true, get: function () { return const_2.DeflistNode; } });
exports.defListType = (0, schema_1.nodeTypeFactory)(const_1.DeflistNode.List);
exports.defTermType = (0, schema_1.nodeTypeFactory)(const_1.DeflistNode.Term);
exports.defDescType = (0, schema_1.nodeTypeFactory)(const_1.DeflistNode.Desc);
const DeflistSpecs = (builder, opts) => {
    const spec = (0, spec_1.getSpec)(opts);
    builder.configureMd((md) => md.use(mdPlugin));
    builder
        .addNode(const_1.DeflistNode.List, () => ({
        spec: spec[const_1.DeflistNode.List],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.DeflistNode.List] },
        toYfm: toYfm_1.toYfm[const_1.DeflistNode.List],
    }))
        .addNode(const_1.DeflistNode.Term, () => ({
        spec: spec[const_1.DeflistNode.Term],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.DeflistNode.Term] },
        toYfm: toYfm_1.toYfm[const_1.DeflistNode.Term],
    }))
        .addNode(const_1.DeflistNode.Desc, () => ({
        spec: spec[const_1.DeflistNode.Desc],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.DeflistNode.Desc] },
        toYfm: toYfm_1.toYfm[const_1.DeflistNode.Desc],
    }));
};
exports.DeflistSpecs = DeflistSpecs;
