import type { Action, ExtensionAuto } from '../../../core';
import { HeadingAction } from './const';
import { HeadingSpecsOptions } from './HeadingSpecs';
export { headingNodeName, headingType } from './HeadingSpecs';
export { HeadingAction } from './const';
export { hType } from './utils';
export declare type HeadingOptions = HeadingSpecsOptions & {
    h1Key?: string | null;
    h2Key?: string | null;
    h3Key?: string | null;
    h4Key?: string | null;
    h5Key?: string | null;
    h6Key?: string | null;
};
export declare const Heading: ExtensionAuto<HeadingOptions>;
declare global {
    namespace YfmEditor {
        interface Actions {
            [HeadingAction.ToH1]: Action;
            [HeadingAction.ToH2]: Action;
            [HeadingAction.ToH3]: Action;
            [HeadingAction.ToH4]: Action;
            [HeadingAction.ToH5]: Action;
            [HeadingAction.ToH6]: Action;
        }
    }
}
