"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toYfm = void 0;
const const_1 = require("./const");
exports.toYfm = {
    [const_1.ListNode.ListItem]: (state, node) => {
        state.renderContent(node);
    },
    [const_1.ListNode.BulletList]: (state, node) => {
        state.renderList(node, '  ', () => (node.attrs.bullet || '*') + ' ');
    },
    [const_1.ListNode.OrderedList]: (state, node) => {
        const start = node.attrs.order || 1;
        const maxW = String(start + node.childCount - 1).length;
        const space = state.repeat(' ', maxW + 2);
        state.renderList(node, space, (i) => {
            const nStr = String(start + i);
            return state.repeat(' ', maxW - nStr.length) + nStr + '. ';
        });
    },
};
