"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkSpecs = exports.markMarkType = exports.markMarkName = void 0;
const schema_1 = require("../../../../utils/schema");
const mdPlugin = require('markdown-it-mark');
exports.markMarkName = 'mark';
exports.markMarkType = (0, schema_1.markTypeFactory)(exports.markMarkName);
const MarkSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(mdPlugin))
        .addMark(exports.markMarkName, () => ({
        spec: {
            parseDOM: [{ tag: 'mark' }],
            toDOM() {
                return ['mark'];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: exports.markMarkName,
                type: 'mark',
            },
        },
        toYfm: {
            open: '==',
            close: '==',
            mixable: true,
            expelEnclosingWhitespace: true,
        },
    }));
};
exports.MarkSpecs = MarkSpecs;
