"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptSpecs = exports.subscriptType = exports.subscriptMarkName = void 0;
const schema_1 = require("../../../../utils/schema");
const sub = require('markdown-it-sub');
exports.subscriptMarkName = 'sub';
exports.subscriptType = (0, schema_1.markTypeFactory)(exports.subscriptMarkName);
const SubscriptSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(sub))
        .addMark(exports.subscriptMarkName, () => ({
        spec: {
            excludes: '_',
            parseDOM: [{ tag: 'sub' }],
            toDOM() {
                return ['sub'];
            },
        },
        toYfm: {
            open: (state) => {
                state.escapeWhitespace = true;
                return '~';
            },
            close: (state) => {
                state.escapeWhitespace = false;
                return '~';
            },
            mixable: false,
            expelEnclosingWhitespace: true,
        },
        fromYfm: { tokenSpec: { name: exports.subscriptMarkName, type: 'mark' } },
    }));
};
exports.SubscriptSpecs = SubscriptSpecs;
