"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableSpecs = exports.TableNode = void 0;
const fromYfm_1 = require("./fromYfm");
const toYfm_1 = require("./toYfm");
const spec_1 = require("./spec");
const const_1 = require("./const");
var const_2 = require("./const");
Object.defineProperty(exports, "TableNode", { enumerable: true, get: function () { return const_2.TableNode; } });
const TableSpecs = (builder) => {
    builder
        .addNode(const_1.TableNode.Table, () => ({
        spec: spec_1.spec[const_1.TableNode.Table],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Table],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Table] },
    }))
        .addNode(const_1.TableNode.Head, () => ({
        spec: spec_1.spec[const_1.TableNode.Head],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Head],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Head] },
    }))
        .addNode(const_1.TableNode.Body, () => ({
        spec: spec_1.spec[const_1.TableNode.Body],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Body],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Body] },
    }))
        .addNode(const_1.TableNode.Row, () => ({
        spec: spec_1.spec[const_1.TableNode.Row],
        toYfm: toYfm_1.toYfm[const_1.TableNode.Row],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.Row] },
    }))
        .addNode(const_1.TableNode.HeaderCell, () => ({
        spec: spec_1.spec[const_1.TableNode.HeaderCell],
        toYfm: toYfm_1.toYfm[const_1.TableNode.HeaderCell],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.HeaderCell] },
    }))
        .addNode(const_1.TableNode.DataCell, () => ({
        spec: spec_1.spec[const_1.TableNode.DataCell],
        toYfm: toYfm_1.toYfm[const_1.TableNode.DataCell],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.TableNode.DataCell] },
    }));
};
exports.TableSpecs = TableSpecs;
