"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Table = exports.TableCellAlign = exports.TableAttrs = exports.TableNode = exports.TableActions = exports.TableHelpers = void 0;
const tslib_1 = require("tslib");
const table_utils_1 = require("../../../table-utils");
const TableSpecs_1 = require("./TableSpecs");
const actions_1 = require("./actions");
const TableHelpers = tslib_1.__importStar(require("./helpers"));
exports.TableHelpers = TableHelpers;
const TableActions = tslib_1.__importStar(require("./actions"));
exports.TableActions = TableActions;
var const_1 = require("./const");
Object.defineProperty(exports, "TableNode", { enumerable: true, get: function () { return const_1.TableNode; } });
Object.defineProperty(exports, "TableAttrs", { enumerable: true, get: function () { return const_1.TableAttrs; } });
Object.defineProperty(exports, "TableCellAlign", { enumerable: true, get: function () { return const_1.CellAlign; } });
const Table = (builder) => {
    builder.use(TableSpecs_1.TableSpecs);
    builder.addKeymap(() => ({
        Tab: (0, table_utils_1.goToNextCell)('next'),
        'Shift-Tab': (0, table_utils_1.goToNextCell)('prev'),
    }));
    builder
        .addAction('createTable', actions_1.createTableAction)
        .addAction('deleteTable', () => actions_1.deleteTableAction);
};
exports.Table = Table;
