"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnderlineSpecs = exports.underlineType = exports.underlineMarkName = void 0;
const schema_1 = require("../../../../utils/schema");
const ins = require('markdown-it-ins');
exports.underlineMarkName = 'ins';
exports.underlineType = (0, schema_1.markTypeFactory)(exports.underlineMarkName);
const UnderlineSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(ins))
        .addMark(exports.underlineMarkName, () => ({
        spec: {
            parseDOM: [{ tag: 'ins' }, { tag: 'u' }],
            toDOM() {
                return ['ins'];
            },
        },
        toYfm: { open: '++', close: '++', mixable: true, expelEnclosingWhitespace: true },
        fromYfm: { tokenSpec: { name: exports.underlineMarkName, type: 'mark' } },
    }));
};
exports.UnderlineSpecs = UnderlineSpecs;
