"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkdownBlocksSpecsPreset = exports.MarkdownMarksSpecsPreset = void 0;
const tslib_1 = require("tslib");
const isFunction_1 = tslib_1.__importDefault(require("lodash/isFunction"));
const BoldSpecs_1 = require("./Bold/BoldSpecs");
const CodeSpecs_1 = require("./Code/CodeSpecs");
const ItalicSpecs_1 = require("./Italic/ItalicSpecs");
const StrikeSpecs_1 = require("./Strike/StrikeSpecs");
const UnderlineSpecs_1 = require("./Underline/UnderlineSpecs");
const LinkSpecs_1 = require("./Link/LinkSpecs");
const MarkSpecs_1 = require("./Mark/MarkSpecs");
const SubscriptSpecs_1 = require("./Subscript/SubscriptSpecs");
const SuperscriptSpecs_1 = require("./Superscript/SuperscriptSpecs");
const Html_1 = require("./Html");
const TableSpecs_1 = require("./Table/TableSpecs");
const ImageSpecs_1 = require("./Image/ImageSpecs");
const ListsSpecs_1 = require("./Lists/ListsSpecs");
const BreaksSpecs_1 = require("./Breaks/BreaksSpecs");
const BlockquoteSpecs_1 = require("./Blockquote/BlockquoteSpecs");
const DeflistSpecs_1 = require("./Deflist/DeflistSpecs");
const HeadingSpecs_1 = require("./Heading/HeadingSpecs");
const HorizontalRuleSpecs_1 = require("./HorizontalRule/HorizontalRuleSpecs");
const CodeBlockSpecs_1 = require("./CodeBlock/CodeBlockSpecs");
tslib_1.__exportStar(require("./Bold/BoldSpecs"), exports);
tslib_1.__exportStar(require("./Code/CodeSpecs"), exports);
tslib_1.__exportStar(require("./Link/LinkSpecs"), exports);
tslib_1.__exportStar(require("./Italic/ItalicSpecs"), exports);
tslib_1.__exportStar(require("./Strike/StrikeSpecs"), exports);
tslib_1.__exportStar(require("./Underline/UnderlineSpecs"), exports);
tslib_1.__exportStar(require("./Mark/MarkSpecs"), exports);
tslib_1.__exportStar(require("./Subscript/SubscriptSpecs"), exports);
tslib_1.__exportStar(require("./Superscript/SuperscriptSpecs"), exports);
tslib_1.__exportStar(require("./Html"), exports);
tslib_1.__exportStar(require("./Breaks/BreaksSpecs"), exports);
tslib_1.__exportStar(require("./Blockquote/BlockquoteSpecs"), exports);
tslib_1.__exportStar(require("./CodeBlock/CodeBlockSpecs"), exports);
tslib_1.__exportStar(require("./Deflist/DeflistSpecs"), exports);
tslib_1.__exportStar(require("./Image/ImageSpecs"), exports);
tslib_1.__exportStar(require("./Lists/ListsSpecs"), exports);
tslib_1.__exportStar(require("./Table/TableSpecs"), exports);
tslib_1.__exportStar(require("./Heading/HeadingSpecs"), exports);
tslib_1.__exportStar(require("./HorizontalRule/HorizontalRuleSpecs"), exports);
const MarkdownMarksSpecsPreset = (builder, _opts) => {
    builder
        .use(BoldSpecs_1.BoldSpecs)
        .use(CodeSpecs_1.CodeSpecs)
        .use(ItalicSpecs_1.ItalicSpecs)
        .use(StrikeSpecs_1.StrikeSpecs)
        .use(UnderlineSpecs_1.UnderlineSpecs)
        .use(LinkSpecs_1.LinkSpecs)
        .use(MarkSpecs_1.MarkSpecs)
        .use(SubscriptSpecs_1.SubscriptSpecs)
        .use(SuperscriptSpecs_1.SuperscriptSpecs);
};
exports.MarkdownMarksSpecsPreset = MarkdownMarksSpecsPreset;
const MarkdownBlocksSpecsPreset = (builder, opts) => {
    var _a, _b, _c;
    builder
        .use(Html_1.Html)
        .use(ListsSpecs_1.ListsSpecs)
        .use(TableSpecs_1.TableSpecs)
        .use(BreaksSpecs_1.BreaksSpecs)
        .use(BlockquoteSpecs_1.BlockquoteSpecs)
        .use(HorizontalRuleSpecs_1.HorizontalRuleSpecs)
        .use(DeflistSpecs_1.DeflistSpecs, (_a = opts.deflist) !== null && _a !== void 0 ? _a : {})
        .use(CodeBlockSpecs_1.CodeBlockSpecs, (_b = opts.codeBlock) !== null && _b !== void 0 ? _b : {});
    if (opts.image !== false) {
        builder.use((0, isFunction_1.default)(opts.image) ? opts.image : ImageSpecs_1.ImageSpecs);
    }
    if (opts.heading !== false) {
        if ((0, isFunction_1.default)(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(HeadingSpecs_1.HeadingSpecs, (_c = opts.heading) !== null && _c !== void 0 ? _c : {});
    }
};
exports.MarkdownBlocksSpecsPreset = MarkdownBlocksSpecsPreset;
