"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckboxSpecs = exports.checkboxInputType = exports.checkboxLabelType = exports.checkboxType = exports.CheckboxNode = void 0;
const tslib_1 = require("tslib");
const checkbox_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/plugins/checkbox"));
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
var const_2 = require("./const");
Object.defineProperty(exports, "CheckboxNode", { enumerable: true, get: function () { return const_2.CheckboxNode; } });
exports.checkboxType = (0, schema_1.nodeTypeFactory)(const_1.CheckboxNode.Checkbox);
exports.checkboxLabelType = (0, schema_1.nodeTypeFactory)(const_1.CheckboxNode.Label);
exports.checkboxInputType = (0, schema_1.nodeTypeFactory)(const_1.CheckboxNode.Input);
const CheckboxSpecs = (builder, opts) => {
    const spec = (0, spec_1.getSpec)(opts);
    builder
        .configureMd((md) => (0, checkbox_1.default)(md, { idPrefix: const_1.idPrefix, divClass: (0, const_1.b)() }))
        .addNode(const_1.CheckboxNode.Checkbox, () => ({
        spec: spec[const_1.CheckboxNode.Checkbox],
        toYfm: toYfm_1.toYfm[const_1.CheckboxNode.Checkbox],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.CheckboxNode.Checkbox],
        },
        view: opts.checkboxView,
    }))
        .addNode(const_1.CheckboxNode.Input, () => ({
        spec: spec[const_1.CheckboxNode.Input],
        toYfm: toYfm_1.toYfm[const_1.CheckboxNode.Input],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.CheckboxNode.Input],
        },
        view: opts.inputView,
    }))
        .addNode(const_1.CheckboxNode.Label, () => ({
        spec: spec[const_1.CheckboxNode.Label],
        toYfm: toYfm_1.toYfm[const_1.CheckboxNode.Label],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.CheckboxNode.Label],
            tokenName: 'checkbox_label',
        },
        view: opts.labelView,
    }));
};
exports.CheckboxSpecs = CheckboxSpecs;
