"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorSpecs = exports.colorType = exports.colorMarkName = void 0;
const tslib_1 = require("tslib");
const markdown_it_color_1 = tslib_1.__importDefault(require("markdown-it-color"));
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
var const_2 = require("./const");
Object.defineProperty(exports, "colorMarkName", { enumerable: true, get: function () { return const_2.colorMarkName; } });
exports.colorType = (0, schema_1.markTypeFactory)(const_1.colorMarkName);
const ColorSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(markdown_it_color_1.default, { defaultClassName: const_1.colorClassName, inline: false }))
        .addMark(const_1.colorMarkName, () => ({
        spec: {
            attrs: { [const_1.colorMarkName]: {} },
            parseDOM: [
                {
                    tag: `span[${const_1.domColorAttr}]`,
                    getAttrs(node) {
                        return {
                            [const_1.colorMarkName]: node.getAttribute(const_1.domColorAttr),
                        };
                    },
                },
            ],
            toDOM(node) {
                const colorValue = node.attrs[const_1.colorMarkName];
                return [
                    'span',
                    {
                        class: [const_1.colorClassName, `${const_1.colorClassName}--${colorValue}`].join(' '),
                        [const_1.domColorAttr]: colorValue,
                    },
                    0,
                ];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: const_1.colorMarkName,
                type: 'mark',
                getAttrs(token) {
                    return {
                        [const_1.colorMarkName]: token.info,
                    };
                },
            },
        },
        toYfm: {
            open: (_state, mark) => {
                return `{${mark.attrs[const_1.colorMarkName]}}(`;
            },
            close: ')',
            mixable: true,
            expelEnclosingWhitespace: true,
        },
    }));
};
exports.ColorSpecs = ColorSpecs;
