"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addImage = void 0;
const tslib_1 = require("tslib");
const is_number_1 = tslib_1.__importDefault(require("is-number"));
const Image_1 = require("../../markdown/Image");
const const_1 = require("./const");
const addImage = (schema) => {
    return {
        isEnable: (state) => state.selection.empty,
        run(state, dispatch, _view, attrs) {
            const params = attrs;
            if (params === null || params === void 0 ? void 0 : params.src) {
                const { src, title, alt, width, height } = params;
                const imgAttrs = {
                    [const_1.ImgSizeAttr.Src]: src,
                    [const_1.ImgSizeAttr.Title]: title !== null && title !== void 0 ? title : '',
                    [const_1.ImgSizeAttr.Alt]: alt !== null && alt !== void 0 ? alt : '',
                };
                if ((0, is_number_1.default)(width)) {
                    imgAttrs[const_1.ImgSizeAttr.Width] = String(width);
                }
                if ((0, is_number_1.default)(height)) {
                    imgAttrs[const_1.ImgSizeAttr.Height] = String(height);
                }
                dispatch(state.tr.insert(state.selection.from, (0, Image_1.imgType)(schema).create(imgAttrs)));
            }
        },
    };
};
exports.addImage = addImage;
