"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSpec = void 0;
const const_1 = require("../const");
const DEFAULT_PLACEHOLDERS = {
    Title: 'Cut title',
    Content: 'Cut content',
};
const getSpec = (opts) => {
    var _a, _b;
    return ({
        [const_1.CutNode.Cut]: {
            attrs: { class: { default: 'yfm-cut' } },
            content: `${const_1.CutNode.CutTitle} ${const_1.CutNode.CutContent}`,
            group: 'block yfm-cut',
            parseDOM: [{ tag: 'div.yfm-cut' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            selectable: true,
            allowSelection: true,
            defining: true,
            complex: 'root',
        },
        [const_1.CutNode.CutTitle]: {
            attrs: { class: { default: 'yfm-cut-title' } },
            content: 'inline*',
            group: 'block yfm-cut',
            parseDOM: [{ tag: 'div.yfm-cut-title' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            placeholder: {
                content: (_a = opts === null || opts === void 0 ? void 0 : opts.yfmCutTitlePlaceholder) !== null && _a !== void 0 ? _a : DEFAULT_PLACEHOLDERS.Title,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
        [const_1.CutNode.CutContent]: {
            attrs: { class: { default: 'yfm-cut-content' } },
            content: '(block | paragraph)+',
            group: 'block yfm-cut',
            parseDOM: [{ tag: 'div.yfm-cut-content' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            placeholder: {
                content: (_b = opts === null || opts === void 0 ? void 0 : opts.yfmCutContentPlaceholder) !== null && _b !== void 0 ? _b : DEFAULT_PLACEHOLDERS.Content,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
    });
};
exports.getSpec = getSpec;
