"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cutAutoOpenPlugin = void 0;
const prosemirror_state_1 = require("prosemirror-state");
const selection_1 = require("../../../../utils/selection");
const const_1 = require("../const");
const key = new prosemirror_state_1.PluginKey('yfm-cut-auto-open');
const cutAutoOpenPlugin = () => new prosemirror_state_1.Plugin({
    key,
    view(view) {
        update(view);
        return {
            update: (view) => update(view),
        };
    },
});
exports.cutAutoOpenPlugin = cutAutoOpenPlugin;
function update(view) {
    const sel = view.state.selection;
    const domAtPos = view.domAtPos.bind(view);
    if ((0, selection_1.isTextSelection)(sel)) {
        if (sel.$cursor) {
            openParentYfmCuts(sel.$cursor, domAtPos);
        }
        else {
            openParentYfmCuts(sel.$head, domAtPos);
            openParentYfmCuts(sel.$anchor, domAtPos);
        }
    }
}
function openParentYfmCuts($pos, domAtPos) {
    let { depth } = $pos;
    const { schema } = $pos.parent.type;
    while (depth > 0) {
        if ($pos.node(depth).type === (0, const_1.cutContentType)(schema)) {
            if ($pos.node(depth - 1).type === (0, const_1.cutType)(schema)) {
                const { node: cutDomNode } = domAtPos($pos.start(depth - 1), 0);
                cutDomNode.classList.add('open');
                depth--;
            }
        }
        depth--;
    }
}
