"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toHeading = exports.resetHeading = void 0;
const prosemirror_commands_1 = require("prosemirror-commands");
const prosemirror_utils_1 = require("prosemirror-utils");
const const_1 = require("./const");
const utils_1 = require("./YfmHeadingSpecs/utils");
var commands_1 = require("../../markdown/Heading/commands");
Object.defineProperty(exports, "resetHeading", { enumerable: true, get: function () { return commands_1.resetHeading; } });
const toHeading = (level) => (state, dispatch) => {
    const parentHeading = (0, prosemirror_utils_1.findParentNodeOfType)((0, utils_1.hType)(state.schema))(state.selection);
    if (parentHeading) {
        dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.setNodeMarkup(parentHeading.pos, undefined, Object.assign(Object.assign({}, parentHeading.node.attrs), { [const_1.YfmHeadingAttr.Level]: level })));
        return true;
    }
    // const text = state.selection.$head.parent.textContent;
    const attrs = {
        // [YfmHeadingAttr.Id]: slugify(text),
        [const_1.YfmHeadingAttr.Level]: level,
    };
    return (0, prosemirror_commands_1.setBlockType)((0, utils_1.hType)(state.schema), attrs)(state, dispatch);
};
exports.toHeading = toHeading;
