"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmNoteSpecs = exports.noteTitleType = exports.noteType = exports.YfmNoteNode = void 0;
const tslib_1 = require("tslib");
const log_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/log"));
const notes_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/plugins/notes"));
const toYfm_1 = require("./toYfm");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
var const_2 = require("./const");
Object.defineProperty(exports, "YfmNoteNode", { enumerable: true, get: function () { return const_2.NoteNode; } });
var utils_1 = require("./utils");
Object.defineProperty(exports, "noteType", { enumerable: true, get: function () { return utils_1.noteType; } });
Object.defineProperty(exports, "noteTitleType", { enumerable: true, get: function () { return utils_1.noteTitleType; } });
const YfmNoteSpecs = (builder, opts) => {
    const spec = (0, spec_1.getSpec)(opts);
    builder
        .configureMd((md) => md.use(notes_1.default, { log: log_1.default }))
        .addNode(const_1.NoteNode.Note, () => ({
        spec: spec[const_1.NoteNode.Note],
        toYfm: toYfm_1.toYfm[const_1.NoteNode.Note],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.NoteNode.Note],
        },
    }))
        .addNode(const_1.NoteNode.NoteTitle, () => ({
        spec: spec[const_1.NoteNode.NoteTitle],
        toYfm: toYfm_1.toYfm[const_1.NoteNode.NoteTitle],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.NoteNode.NoteTitle],
        },
    }));
};
exports.YfmNoteSpecs = YfmNoteSpecs;
