"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmTableSpecs = exports.yfmTableCellType = exports.yfmTableRowType = exports.yfmTableBodyType = exports.yfmTableType = exports.YfmTableNode = void 0;
const tslib_1 = require("tslib");
const log_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/log"));
const table_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/plugins/table"));
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
var const_2 = require("./const");
Object.defineProperty(exports, "YfmTableNode", { enumerable: true, get: function () { return const_2.YfmTableNode; } });
var utils_1 = require("./utils");
Object.defineProperty(exports, "yfmTableType", { enumerable: true, get: function () { return utils_1.yfmTableType; } });
Object.defineProperty(exports, "yfmTableBodyType", { enumerable: true, get: function () { return utils_1.yfmTableBodyType; } });
Object.defineProperty(exports, "yfmTableRowType", { enumerable: true, get: function () { return utils_1.yfmTableRowType; } });
Object.defineProperty(exports, "yfmTableCellType", { enumerable: true, get: function () { return utils_1.yfmTableCellType; } });
const YfmTableSpecs = (builder, options) => {
    const spec = (0, spec_1.getSpec)(options);
    builder
        .configureMd((md) => md.use(table_1.default, { log: log_1.default }))
        .addNode(const_1.YfmTableNode.Table, () => ({
        spec: spec[const_1.YfmTableNode.Table],
        toYfm: toYfm_1.toYfm[const_1.YfmTableNode.Table],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.YfmTableNode.Table] },
    }))
        .addNode(const_1.YfmTableNode.Body, () => ({
        spec: spec[const_1.YfmTableNode.Body],
        toYfm: toYfm_1.toYfm[const_1.YfmTableNode.Body],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.YfmTableNode.Body] },
    }))
        .addNode(const_1.YfmTableNode.Row, () => ({
        spec: spec[const_1.YfmTableNode.Row],
        toYfm: toYfm_1.toYfm[const_1.YfmTableNode.Row],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.YfmTableNode.Row] },
    }))
        .addNode(const_1.YfmTableNode.Cell, () => ({
        spec: spec[const_1.YfmTableNode.Cell],
        toYfm: toYfm_1.toYfm[const_1.YfmTableNode.Cell],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.YfmTableNode.Cell] },
    }));
};
exports.YfmTableSpecs = YfmTableSpecs;
