"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmTabsSpecs = exports.tabsListType = exports.tabsType = exports.tabType = exports.tabPanelType = exports.TabsNode = void 0;
const tslib_1 = require("tslib");
const log_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/log"));
const tabs_1 = tslib_1.__importDefault(require("@doc-tools/transform/lib/plugins/tabs"));
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
var const_2 = require("./const");
Object.defineProperty(exports, "TabsNode", { enumerable: true, get: function () { return const_2.TabsNode; } });
exports.tabPanelType = (0, schema_1.nodeTypeFactory)(const_1.TabsNode.TabPanel);
exports.tabType = (0, schema_1.nodeTypeFactory)(const_1.TabsNode.Tab);
exports.tabsType = (0, schema_1.nodeTypeFactory)(const_1.TabsNode.Tabs);
exports.tabsListType = (0, schema_1.nodeTypeFactory)(const_1.TabsNode.TabsList);
const YfmTabsSpecs = (builder, opts) => {
    const spec = (0, spec_1.getSpec)(opts);
    builder
        .configureMd((md) => md.use(tabs_1.default, { log: log_1.default }))
        .addNode(const_1.TabsNode.Tab, () => ({
        spec: spec[const_1.TabsNode.Tab],
        toYfm: toYfm_1.toYfm[const_1.TabsNode.Tab],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.TabsNode.Tab],
            tokenName: 'tab',
        },
        view: opts.tabView,
    }))
        .addNode(const_1.TabsNode.TabsList, () => ({
        spec: spec[const_1.TabsNode.TabsList],
        toYfm: toYfm_1.toYfm[const_1.TabsNode.TabsList],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.TabsNode.TabsList],
            tokenName: 'tab-list',
        },
        view: opts.tabsListView,
    }))
        .addNode(const_1.TabsNode.TabPanel, () => ({
        spec: spec[const_1.TabsNode.TabPanel],
        toYfm: toYfm_1.toYfm[const_1.TabsNode.TabPanel],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.TabsNode.TabPanel],
            tokenName: 'tab-panel',
        },
        view: opts.tabPanelView,
    }))
        .addNode(const_1.TabsNode.Tabs, () => ({
        spec: spec[const_1.TabsNode.Tabs],
        toYfm: toYfm_1.toYfm[const_1.TabsNode.Tabs],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.TabsNode.Tabs],
            tokenName: 'tabs',
        },
        view: opts.tabsView,
    }));
};
exports.YfmTabsSpecs = YfmTabsSpecs;
