"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.appendRow = void 0;
const prosemirror_model_1 = require("prosemirror-model");
const prosemirror_utils_1 = require("prosemirror-utils");
const __1 = require("..");
const appendRow = (state, dispatch, _, attrs) => {
    var _a;
    if (!attrs)
        return false;
    const { tablePos, rowNumber, direction } = attrs;
    const tableNode = (_a = (0, prosemirror_utils_1.findParentNodeClosestToPos)(state.doc.resolve(tablePos + 1), __1.isTableNode)) === null || _a === void 0 ? void 0 : _a.node;
    if (!tableNode)
        return false;
    let parentRow;
    if (rowNumber !== undefined) {
        parentRow = (0, __1.findChildTableRows)(tableNode)[rowNumber];
    }
    else {
        parentRow = (0, __1.findChildTableRows)(tableNode).pop();
    }
    const parentBody = (0, __1.findChildTableBody)(tableNode).pop();
    if (!parentRow || !parentBody) {
        return false;
    }
    if (dispatch) {
        const newCellNodes = [];
        parentRow.node.forEach((node) => {
            newCellNodes.push(node.type.createAndFill(node.attrs));
        });
        let position = tablePos + parentRow.pos;
        position += direction === 'before' ? 1 : parentRow.node.nodeSize;
        dispatch(state.tr.insert(position, parentRow.node.copy(prosemirror_model_1.Fragment.from(newCellNodes))));
    }
    return true;
};
exports.appendRow = appendRow;
