import { undoInputRule } from 'prosemirror-inputrules';
import { baseKeymap, joinDown, joinUp, lift, selectParentNode } from 'prosemirror-commands';
/**
 * Add this extension after all other extensions with keymaps
 */
export const BaseKeymap = (builder) => {
    builder
        .addKeymap(() => ({
        Backspace: undoInputRule,
        'Alt-ArrowUp': joinUp,
        'Alt-ArrowDown': joinDown,
        'Mod-BracketLeft': lift,
        'Alt-Shift-Escape': selectParentNode,
    }), builder.PluginPriority.Lowest)
        .addKeymap(() => baseKeymap, builder.PluginPriority.Lowest);
};
