import { markTypeFactory } from '../../../../utils/schema';
const mdPlugin = require('markdown-it-mark');
export const markMarkName = 'mark';
export const markMarkType = markTypeFactory(markMarkName);
export const MarkSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(mdPlugin))
        .addMark(markMarkName, () => ({
        spec: {
            parseDOM: [{ tag: 'mark' }],
            toDOM() {
                return ['mark'];
            },
        },
        fromYfm: {
            tokenSpec: {
                name: markMarkName,
                type: 'mark',
            },
        },
        toYfm: {
            open: '==',
            close: '==',
            mixable: true,
            expelEnclosingWhitespace: true,
        },
    }));
};
