import log from '@doc-tools/transform/lib/log';
import sup from '@doc-tools/transform/lib/plugins/sup';
import { markTypeFactory } from '../../../../utils/schema';
export const superscriptMarkName = 'sup';
export const superscriptType = markTypeFactory(superscriptMarkName);
export const SuperscriptSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(sup, { log }))
        .addMark(superscriptMarkName, () => ({
        spec: {
            excludes: '_',
            parseDOM: [{ tag: 'sup' }],
            toDOM() {
                return ['sup'];
            },
        },
        toYfm: {
            open: (state) => {
                state.escapeWhitespace = true;
                return '^';
            },
            close: (state) => {
                state.escapeWhitespace = false;
                return '^';
            },
            mixable: true,
            expelEnclosingWhitespace: true,
        },
        fromYfm: { tokenSpec: { name: superscriptMarkName, type: 'mark' } },
    }));
};
