import { createToggleMarkAction } from '../../../utils/actions';
import { markInputRule } from '../../../utils/inputrules';
import { superscriptMarkName, SuperscriptSpecs, superscriptType } from './SuperscriptSpecs';
export { superscriptMarkName, superscriptType } from './SuperscriptSpecs';
/** @deprecated Use `superscriptMarkName` instead */
export const superscript = superscriptMarkName;
const supAction = 'supscript';
export const Superscript = (builder) => {
    builder.use(SuperscriptSpecs);
    builder
        .addAction(supAction, ({ schema }) => createToggleMarkAction(superscriptType(schema)))
        .addInputRules(({ schema }) => ({
        rules: [
            markInputRule({ open: '^', close: '^', ignoreBetween: '^' }, superscriptType(schema)),
        ],
    }));
};
