import type { Extension, ExtensionAuto } from '../../core';
import { BoldOptions } from './Bold';
import { CodeOptions } from './Code';
import { ItalicOptions } from './Italic';
import { StrikeOptions } from './Strike';
import { UnderlineOptions } from './Underline';
import { ListsOptions } from './Lists';
import { BreaksOptions } from './Breaks';
import { DeflistOptions } from './Deflist';
import { HeadingOptions } from './Heading';
import { CodeBlockOptions } from './CodeBlock';
import { BlockquoteOptions } from './Blockquote';
export * from './Bold';
export * from './Code';
export * from './Link';
export * from './Italic';
export * from './Strike';
export * from './Underline';
export * from './Mark';
export * from './Subscript';
export * from './Superscript';
export * from './Html';
export * from './Breaks';
export * from './Blockquote';
export * from './CodeBlock';
export * from './Deflist';
export * from './Lists';
export * from './Image';
export * from './Table';
export * from './Heading';
export * from './HorizontalRule';
export declare type MarkdownMarksPresetOptions = {
    bold?: BoldOptions;
    italic?: ItalicOptions;
    strike?: StrikeOptions;
    underline?: UnderlineOptions;
    code?: CodeOptions;
};
export declare const MarkdownMarksPreset: ExtensionAuto<MarkdownMarksPresetOptions>;
export declare type MarkdownBlocksPresetOptions = {
    image?: false | Extension;
    lists?: ListsOptions;
    breaks?: BreaksOptions;
    deflist?: DeflistOptions;
    codeBlock?: CodeBlockOptions;
    blockquote?: BlockquoteOptions;
    heading?: false | Extension | HeadingOptions;
};
export declare const MarkdownBlocksPreset: ExtensionAuto<MarkdownBlocksPresetOptions>;
