import isFunction from 'lodash/isFunction';
import { BoldSpecs } from './Bold/BoldSpecs';
import { CodeSpecs } from './Code/CodeSpecs';
import { ItalicSpecs } from './Italic/ItalicSpecs';
import { StrikeSpecs } from './Strike/StrikeSpecs';
import { UnderlineSpecs } from './Underline/UnderlineSpecs';
import { LinkSpecs } from './Link/LinkSpecs';
import { MarkSpecs } from './Mark/MarkSpecs';
import { SubscriptSpecs } from './Subscript/SubscriptSpecs';
import { SuperscriptSpecs } from './Superscript/SuperscriptSpecs';
import { Html } from './Html';
import { TableSpecs } from './Table/TableSpecs';
import { ImageSpecs } from './Image/ImageSpecs';
import { ListsSpecs } from './Lists/ListsSpecs';
import { BreaksSpecs } from './Breaks/BreaksSpecs';
import { BlockquoteSpecs } from './Blockquote/BlockquoteSpecs';
import { DeflistSpecs } from './Deflist/DeflistSpecs';
import { HeadingSpecs } from './Heading/HeadingSpecs';
import { HorizontalRuleSpecs } from './HorizontalRule/HorizontalRuleSpecs';
import { CodeBlockSpecs } from './CodeBlock/CodeBlockSpecs';
export * from './Bold/BoldSpecs';
export * from './Code/CodeSpecs';
export * from './Link/LinkSpecs';
export * from './Italic/ItalicSpecs';
export * from './Strike/StrikeSpecs';
export * from './Underline/UnderlineSpecs';
export * from './Mark/MarkSpecs';
export * from './Subscript/SubscriptSpecs';
export * from './Superscript/SuperscriptSpecs';
export * from './Html';
export * from './Breaks/BreaksSpecs';
export * from './Blockquote/BlockquoteSpecs';
export * from './CodeBlock/CodeBlockSpecs';
export * from './Deflist/DeflistSpecs';
export * from './Image/ImageSpecs';
export * from './Lists/ListsSpecs';
export * from './Table/TableSpecs';
export * from './Heading/HeadingSpecs';
export * from './HorizontalRule/HorizontalRuleSpecs';
export const MarkdownMarksSpecsPreset = (builder, _opts) => {
    builder
        .use(BoldSpecs)
        .use(CodeSpecs)
        .use(ItalicSpecs)
        .use(StrikeSpecs)
        .use(UnderlineSpecs)
        .use(LinkSpecs)
        .use(MarkSpecs)
        .use(SubscriptSpecs)
        .use(SuperscriptSpecs);
};
export const MarkdownBlocksSpecsPreset = (builder, opts) => {
    var _a, _b, _c;
    builder
        .use(Html)
        .use(ListsSpecs)
        .use(TableSpecs)
        .use(BreaksSpecs)
        .use(BlockquoteSpecs)
        .use(HorizontalRuleSpecs)
        .use(DeflistSpecs, (_a = opts.deflist) !== null && _a !== void 0 ? _a : {})
        .use(CodeBlockSpecs, (_b = opts.codeBlock) !== null && _b !== void 0 ? _b : {});
    if (opts.image !== false) {
        builder.use(isFunction(opts.image) ? opts.image : ImageSpecs);
    }
    if (opts.heading !== false) {
        if (isFunction(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(HeadingSpecs, (_c = opts.heading) !== null && _c !== void 0 ? _c : {});
    }
};
