import { createToggleMarkAction } from '../../../utils/actions';
import { markInputRule } from '../../../utils/inputrules';
import { monospaceMarkName, MonospaceSpecs, monospaceType } from './MonospaceSpecs';
export { monospaceMarkName, monospaceType } from './MonospaceSpecs';
/** @deprecated Use `monospaceMarkName` instead */
export const monospace = monospaceMarkName;
const monoAction = 'mono';
export const Monospace = (builder) => {
    builder.use(MonospaceSpecs);
    builder
        .addAction(monoAction, ({ schema }) => createToggleMarkAction(monospaceType(schema)))
        .addInputRules(({ schema }) => ({
        rules: [
            markInputRule({ open: '##', close: '##', ignoreBetween: '#' }, monospaceType(schema)),
        ],
    }));
};
