import log from '@doc-tools/transform/lib/log';
import yfmPlugin from '@doc-tools/transform/lib/plugins/cut';
import { nodeTypeFactory } from '../../../../utils/schema';
import { CutNode } from './const';
import { fromYfm } from './fromYfm';
import { getSpec } from './spec';
import { toYfm } from './toYfm';
export { CutNode } from './const';
export const cutType = nodeTypeFactory(CutNode.Cut);
export const cutTitleType = nodeTypeFactory(CutNode.CutTitle);
export const cutContentType = nodeTypeFactory(CutNode.CutContent);
export const YfmCutSpecs = (builder, opts) => {
    const spec = getSpec(opts);
    builder
        .configureMd((md) => md.use(yfmPlugin, { log }))
        .addNode(CutNode.Cut, () => ({
        spec: spec[CutNode.Cut],
        toYfm: toYfm[CutNode.Cut],
        fromYfm: {
            tokenSpec: fromYfm[CutNode.Cut],
        },
        view: opts.cutView,
    }))
        .addNode(CutNode.CutTitle, () => ({
        spec: spec[CutNode.CutTitle],
        toYfm: toYfm[CutNode.CutTitle],
        fromYfm: {
            tokenSpec: fromYfm[CutNode.CutTitle],
        },
        view: opts.cutTitleView,
    }))
        .addNode(CutNode.CutContent, () => ({
        spec: spec[CutNode.CutContent],
        toYfm: toYfm[CutNode.CutContent],
        fromYfm: {
            tokenSpec: fromYfm[CutNode.CutContent],
        },
        view: opts.cutContentView,
    }));
};
