import React from 'react';
import { useUpdate } from 'react-use';
import { YfmEditor } from '../core';
export function useYfmEditor(props) {
    const rerender = useUpdate();
    const changeRef = React.useRef(props.onChange);
    changeRef.current = props.onChange;
    const editor = React.useMemo(() => {
        return new YfmEditor(Object.assign(Object.assign({}, props), { onChange(e) {
                var _a;
                (_a = changeRef.current) === null || _a === void 0 ? void 0 : _a.call(changeRef, e);
                // need to re-render react view, based on editor state
                rerender();
            } }));
    }, [props.extensions, props.allowHTML, props.linkify, props.linkifyTlds]);
    // Commented out for support react@18 strict mode
    // React.useEffect(() => {
    //     return () => {
    //         editor.destroy();
    //     };
    // }, [editor]);
    return editor;
}
